=== debian/changelog ===
pforth (1:2.0.1-1) unstable; urgency=low

  * new upsgream version, fixes test suite on 32 bit architectures

 -- Bdale Garbee <bdale@gag.com>  Mon, 09 Jan 2023 16:55:24 -0700

pforth (1:2.0.0-1) unstable; urgency=low

  * add version epoch due to upstream change in version number format
  * new upstream version, closes: #791945
  * enable build on arm64, closes: #791946
  * switch to 3.0 (quilt) source format, closes: #1007613
  * upgrade to modern debhelper, control file contents

 -- Bdale Garbee <bdale@gag.com>  Mon, 02 Jan 2023 14:13:49 -0700

pforth (21-12) unstable; urgency=low

  * add Vcs entries to the control file
  * add powerpcspe to architecture list, closes: #731651
  * add armhf to architecture list by request of Luca Masini

 -- Bdale Garbee <bdale@gag.com>  Sun, 12 Jan 2014 14:01:24 -0700

pforth (21-11) unstable; urgency=low

  * add armeb and armel to architecture list, closes: #408789

 -- Bdale Garbee <bdale@gag.com>  Sun, 18 Feb 2007 15:11:53 -0800

pforth (21-10) unstable; urgency=low

  * add kfreebsd-i386 to the list of buildable architectures, closes: #314812
  * clean up debian/copyright file, closes: #302978
  * move to newer debhelper compat level, fix assorted lintian warnings

 -- Bdale Garbee <bdale@gag.com>  Sun, 17 Jul 2005 13:55:20 +0300

pforth (21-9) unstable; urgency=low

  * add hppa to list of supported architectures, closes: #131276
  * lose the '-x c++' from the Makefile, since it appears bogus (pForth is 
    ANSI C, not C++) and hppa fails to link if it is using gcc for C++.  
    Thanks to James Troup for figuring this out.
  * clean up a few cosmetic uglies and make lintian happy

 -- Bdale Garbee <bdale@gag.com>  Mon, 28 Jan 2002 09:20:13 -0700

pforth (21-8) unstable; urgency=low

  * add s390 to list of supported architectures, closes: #127760

 -- Bdale Garbee <bdale@gag.com>  Fri,  4 Jan 2002 10:08:52 -0700

pforth (21-7) unstable; urgency=low

  * clean up lintian reports

 -- Bdale Garbee <bdale@gag.com>  Tue,  1 Jan 2002 10:30:48 -0700

pforth (21-6) unstable; urgency=low

  * add hurd-i386 to supported architectures in control, closes: #55122

 -- Bdale Garbee <bdale@gag.com>  Fri, 14 Jan 2000 23:51:08 -0700

pforth (21-5) unstable; urgency=low

  * prefix invocation of new pforth binary in makefile with './' so that '.'
    doesn't need to be in builder's path.  Closes: #53627

 -- Bdale Garbee <bdale@gag.com>  Tue, 28 Dec 1999 10:42:18 -0700

pforth (21-4) unstable; urgency=low

  * recompile so libstdc++ dependency is current for potato, closes: #53452
  * building on alpha was "fixed" in -3 by using an explicit arch list, and
    there's no sign of an alpha port.  Closes: #39298

 -- Bdale Garbee <bdale@gag.com>  Mon, 27 Dec 1999 11:16:32 -0700

pforth (21-3) unstable; urgency=low

  * switch to an explicit architecture specification in the control file,
    since this is a 32-bit implementation, doesn't work on alpha, and is
    unlikely to work out of the box on other new processors that come along.

 -- Bdale Garbee <bdale@gag.com>  Sat, 19 Jun 1999 10:45:10 -0600

pforth (21-2) unstable; urgency=low

  * oops, fix a typo in the man page
  * include the rest of the documentation provided with the upstream sources

 -- Bdale Garbee <bdale@gag.com>  Sun, 27 Dec 1998 12:22:42 -0700

pforth (21-1) unstable; urgency=low

  * move to newer upstream source pointed out by author
  * implement central default location for pforth.dic file, providing diffs 
    to upstream author

 -- Bdale Garbee <bdale@gag.com>  Sun, 27 Dec 1998 09:16:11 -0700

pforth (19-1) unstable; urgency=low

  * Initial packaging of pforth, never uploaded.

 -- Bdale Garbee <bdale@gag.com>  Thu, 24 Dec 1998 01:55:27 -0700
