=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	true

override_dh_auto_build:
	(cd platforms/unix ; make clean test)
	mv platforms/unix/pforth_standalone platforms/unix/pforth

override_dh_auto_clean:
	(cd platforms/unix ; make clean)
	rm -f platforms/unix/pforth
